#include"PID.h"
#include"string.h"
#include "msp430g2553.h"
//#include"math.h"

//float Result=0,LastResult=40;	     // PIDļ
PID voltage;                         // ṹ
PID current;

//ʼ
void PID_Parameter_Init(PID *pp,float setpoint,float Proportion,float Integral, float Differential,int LAST_OUT)
{    
    memset(pp,0,sizeof(PID));	            // ʼṹ ȫʼΪ0

    pp->SetPoint     =  setpoint;           // 趨Ŀ Desired Value      
    pp->Proportion   =  Proportion;         //  Proportional Const  
    pp->Integral     =  Integral;           // ֳ Integral Const
    pp->Differential =  Differential;
    pp->last_pid_out =  LAST_OUT;
    
  //  pp->pid_out      =  pid_out0;
   // pp->last_pid_out =  pid_out0;
    // ΢ֳ Differential Const  
}

//PID㺯 
//
float PID_Calc(PID *pp, float NextPoint )  
{  	
    float Error;
    unsigned char flag_max=0,flag_min=0;
    Error = pp->SetPoint - NextPoint;          // ƫ

     if(pp->pid_out>MAX)                             // ֻۼӸƫ                      
    {   
        if(Error>=0)
        {
            Error=0;
        }
        flag_max=1;         
    }
    if(pp->pid_out<MIN)                             // ֻۼƫ 
    {
        if(Error<=0)
        {
           Error=0;
        }
        flag_min=1; 
    }  
    //PID   
    pp->pid_out = pp->last_pid_out
	      + (float)pp->Proportion   * (Error - pp->LastError)                       // 
	      + (float)pp->Integral     *  Error	                                //  
              + (float)pp->Differential * (Error - 2*(pp->LastError) + pp->PrevError);  // ΢
     
 
    if(flag_max)
    {   
        flag_max = 0;
        pp->pid_out=MAX;
    }
    if(flag_min)
    {
        flag_min = 0;
        pp->pid_out=MIN;
    }     
    pp->PrevError = pp->LastError;		       // 򵥸ֵ
    pp->LastError = Error; 			       // 򵥸ֵ
    pp->last_pid_out= pp->pid_out;			       // 򵥸ֵ
   
    return pp->pid_out;
    
} 
