#include<msp430g2553.h>
//ģʽ  0->TACCRx|0->TACCRx|0->TACCRx......T=(TACCRx+1)
//ģʽ    0->TACCRx|0->TACCRx|0->TACCRx......T=(TACCRx+1)
//ģʽ    0->TACCRx|TACCRx->0|0->TACCRx......T=2*TACCRx

//ע⣺TA1CCR0>TA1CCR1>TA1CCR2
//      ʹupdowmģʽҪ2*,ģʽ+1.
 
unsigned int R0 = 3960,R1 = 1980,t = -1,s = 0;
unsigned int TEMP1 = 250,TEMP2 = 125;

//unsigned int table[]={2000,1000,667,500,400,333,286,250,222,200};
unsigned int table[]={3960,1980,1326,994,800,750,560,450,440,400};

void Key_Scan(void);
//delay 10us
void Delay(unsigned int us)    //ʱ10*us US
{
  while(--us)
  {
     _NOP();                   //һ  1/1mhz=1us
     _NOP();
     _NOP();
     _NOP();
     _NOP();
  } 
}
//delay ms
void DelayMS(unsigned int iMs)
{
 unsigned int i,j;
   for(i=0;i<iMs;i++)
      for(j=0;j<100;j++) Delay(1);
      
}
void Key_Scan(void)
{
  int temp;
  temp = P1IN & 0x0f;
  
  
 
  switch(temp)
  {
    
    case 0x0e:
      t++;
      if(t == 10)
        t = 0;
      R0 = table[t];
      R1 = table[t]/2;
      
      
  
      P1OUT^=0X40;
      DelayMS(1000);
      break;
  
  
    case 0x0d:
      t--;
      if(t == -1)
        t = 9;
      R0 = table[t];
      R1 = table[t]/2;
      
      
  
      P1OUT^=0X40;
      DelayMS(1000);
      break;
      
    case 0x0b:
      //R0 = table[t];
      s = R0/10;
      R1 += s;
          
      
      P1OUT^=0X40;
      DelayMS(1000);
      break;
      
    case 0x07:
      //R0 = table[t];
      s = R0/10;
      R1 -= s;
      P1OUT^=0X40;
      DelayMS(1000);
      break;
  }
  
  TA1CCR0=R0;
  TA1CCR1=R1;
  
}

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;                 // Stop WDT
  P2DIR |= 0x3F;                            // P2.(0-5) output
  P2OUT |= 0x13;                            // P2.(0,1,4)ߵƽ
  
  P1DIR |= 0x40;

  //DCOʱУ1.1M->16M
  BCSCTL1 = CALBC1_8MHZ;                    // Set DCO    1.1 /8/12/16
  DCOCTL  = CALDCO_8MHZ;                    //              1 /8/12/16


  //TIMTER1_A3
  TA1CTL=TASSEL_2+TACLR+MC_3+TAIE;            //SMCLKƵ,ģʽ,,ʹж
  TA1CCTL0=CCIE;                              //ʹܱȽж
  TA1CCTL1=CCIE;                              //ʹܱȽж
  
  TA1CCR0=R0;
  TA1CCR1=R1;
  
  _BIS_SR(GIE);                 // Enter LPM0 w/ interrupt
  while(1)
  {
    
    Key_Scan();
  }
}

// Timer A1 interrupt service routine
#pragma vector=TIMER1_A0_VECTOR
__interrupt void Timer1_A0INT (void)
{
    if(TEMP1!=R0)
    {
    TA1CCR0=R0;
    TA1CCR1=R1;
    TEMP1=R0;
    }
    P2OUT ^= 0x04;                            // Toggle P2.2
}
// Timer A1 interrupt service routine
#pragma vector=TIMER1_A1_VECTOR
__interrupt void Timer1_A1INT (void)
{
  switch( TA1IV )
  {
  case  TA1IV_TACCR1:
    {
           P2OUT ^= 0x02;                 // Toggle P2.1
           break;
    }
  case  TA1IV_TAIFG:
    {
           P2OUT ^= 0x01;                 // Toggle P2.0
           break;
    }
 }
}
